SystemOrganization addCategory: #FixedDecimal!

!Fraction class methodsFor: '*FixedDecimal' stamp: 'cbc 6/13/2005 15:22'!
readFromString: aString
	"Create an object based on the contents of aString."
	| string |

	string := (aString includes: $/) ifTrue: [aString] ifFalse: [aString, '/1'].
	^self readFrom: (ReadStream on: string)! !

Number subclass: #FixedDecimal
	instanceVariableNames: 'number scale part1 part2 negative'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FixedDecimal'!

!FixedDecimal class methodsFor: 'as yet unclassified' stamp: 'cbc 8/22/2006 16:50'!
newFromFixedDecimal: aDecimal scale: scaleIn 
	"Answer a new instance of me."
	| part2 |

	part2 := (aDecimal part2 * (10 raisedToInteger: (scaleIn - aDecimal scale))) rounded.
	^self basicNew setPart1: aDecimal part1 part2: part2 scale: scaleIn negative: (aDecimal < FixedDecimal zero)! !

!FixedDecimal class methodsFor: 'as yet unclassified' stamp: 'cbc 8/15/2006 11:42'!
newFromNumber: aNumber scale: scaleIn 
	"Answer a new instance of me."
	| temp part1 part2 |

	(aNumber isKindOf: FixedDecimal) ifTrue: [^self newFromFixedDecimal: aNumber scale: scaleIn].
	temp := aNumber asFraction.
	part1 := temp truncated.
	part2 := (temp fractionPart * (10 raisedToInteger: scaleIn)) rounded.
	part2 asString size > scaleIn ifTrue: ["Rounding can get us here..."
		temp := (temp * (10 raisedToInteger: scaleIn)) rounded / (10 raisedToInteger: scaleIn).
		part1 := temp truncated.
		part2 := (temp fractionPart * (10 raisedToInteger: scaleIn)) rounded.
		].
	^self basicNew setPart1: part1 part2: part2 scale: scaleIn negative: (temp < 0)! !

!FixedDecimal class methodsFor: 'as yet unclassified' stamp: 'Merge version 5 and 6. 10/10/2005 15:48'!
newFromString: aNumberString scale: scaleIn
	"Answer a new instance of me.
	String is assumed to be of the format: '293492.230' "
	| temp part1 part2 |

	temp := aNumberString readStream.
	part1 := (temp upTo: $.) asSignedInteger.
	temp atEnd ifTrue: [	^self basicNew setPart1: part1 part2: 0 scale: scaleIn negative: (part1 < 0)].
	part2 := temp next: scaleIn.
	part2 := part2 asInteger * (10 raisedTo: (scaleIn - part2 size)).
	^self basicNew setPart1: part1 part2: part2 scale: scaleIn negative: (aNumberString includes: $-)! !

!FixedDecimal class methodsFor: 'testing' stamp: 'cbc 8/15/2006 11:38'!
testBoundaryIssues
	self assert: [(FixedDecimal newFromNumber: (407584 * 100 / 5112120) scale: 1) printString = '8.0']! !

!FixedDecimal class methodsFor: 'as yet unclassified' stamp: 'cbc 8/22/2006 16:48'!
zero
	^self newFromNumber: 0 scale: 0! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 2/20/2006 15:14'!
< aNumber
	"Implementation of Number 'comparing' method."
	aNumber isNumber ifFalse: [^ false].
	(aNumber isKindOf: FixedDecimal) ifTrue: [^self lessThanDecimal: aNumber].
	^aNumber adaptToFixedDecimal: self andSend: #<! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 3/11/2005 16:06'!
= aNumber
	"Implementation of Number 'comparing' method."
	aNumber isNumber ifFalse: [^ false].
	(aNumber isKindOf: FixedDecimal) ifTrue: [^self equalsDecimal: aNumber].
	^aNumber adaptToFixedDecimal: self andSend: #=! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 3/11/2005 16:09'!
asScale: newScale
	scale = newScale ifTrue: [^self].
	^self class newFromFixedDecimal: self scale: newScale ! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 3/11/2005 16:08'!
equalsDecimal: decimal
	| maxScale |

	decimal scale = scale ifTrue: [^decimal number = number].
	maxScale _ decimal scale max: scale.
	^(self asScale: maxScale) = (decimal asScale: maxScale)! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 8/23/2006 08:52'!
lessThanDecimal: decimal
	| maxScale |

	decimal scale = scale ifTrue: [^number < decimal number].
	maxScale := decimal scale max: scale.
	^(self asScale: maxScale) < (decimal asScale: maxScale)! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 3/11/2005 16:12'!
number
	^number! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 3/11/2005 16:11'!
part1
	^part1! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 3/11/2005 16:11'!
part2
	^part2! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'Merge version 5 and 6. 10/10/2005 14:58'!
printOn: aStream 
	| p2 |

	negative ifTrue: [aStream nextPut: $-].
	scale = 0 ifTrue: [aStream nextPutAll: part1 asString. ^self].
	p2 := part2 asString.
	p2 := String streamContents: [:s| 
		p2 size + 1 to: scale do: [:x| s nextPut: $0].
		s nextPutAll: p2.
		].
	aStream nextPutAll: part1 asString; nextPut: $.; nextPutAll: p2.! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'Merge version 5 and 6. 10/10/2005 14:59'!
printOn: aStream precision: precise
	| p2 p1 |

	p1 := part1 asString.
	p1 size + scale > precise ifTrue: [^nil].
	p1 := String streamContents: [:s|
		negative ifTrue: [s nextPut: $-].
		p1 size + 1 to: (precise - scale) do: [:x| s nextPut: $0].
		precise - scale > 0 ifTrue: [s nextPutAll: p1].
		].
	scale = 0 ifTrue: [aStream nextPutAll: p1. ^self].
	p2 := part2 asString.
	p2 := String streamContents: [:s| 
		p2 size + 1 to: scale do: [:x| s nextPut: $0].
		s nextPutAll: p2.
		].
	aStream nextPutAll: p1; nextPut: $.; nextPutAll: p2.! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'Merge version 5 and 6. 10/10/2005 14:58'!
printOn: aStream precision: precise reserveSign: boolean
	"ReserveSign, if true, means that if we are not negative, then we should preceed the number with a 0.  So that the numbers will ALWAYS be the same size when printed."
	| p2 p1 |

	p1 := part1 asString.
	p1 size + scale > precise ifTrue: [Error signal: 'Decimal is too big to print!!'].
	negative ifTrue: [aStream nextPut: $-] ifFalse: [boolean ifTrue: [aStream nextPut: $+]].
	p1 size + 1 to: (precise - scale) do: [:x| aStream nextPut: $0].
	precise - scale > 0 ifTrue: [aStream nextPutAll: p1].
	scale = 0 ifTrue: [
		boolean ifTrue: [aStream nextPut: $.].
		^self
		].
	aStream nextPut: $..
	p2 := part2 asString.
	p2 size + 1 to: scale do: [:x| aStream nextPut: $0].
	aStream nextPutAll: p2.
! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 10/14/2005 14:40'!
printString
	^String streamContents: [:s| self printOn: s]! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 3/11/2005 16:12'!
scale
	^scale! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'Merge version 5 and 6. 10/10/2005 15:48'!
setPart1: part1In part2: part2In scale: scaleIn negative: boolean

	part1 := part1In abs.
	part2 := part2In abs.
	scale := scaleIn.
	negative := boolean.
	number := (part1 * (10 raisedToInteger: scale)) + part2.
	negative ifTrue: [number := 0 - number].! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 6/13/2005 15:38'!
truncated
	^part1! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 7/19/2007 10:01'!
usedMagnitude
	^part1 asString size! !

!FixedDecimal methodsFor: 'as yet unclassified' stamp: 'cbc 7/19/2007 10:01'!
usedScale
	^part2 asString size! !
